#include "mainheader.h"
#include "resource.h"
#include "Patcher.h"

HINSTANCE hInst;
HWND mainwindow, child;
OPENFILENAME ofn;
char selectedFiles[512];
char *params;
BYTE mode;

INT_PTR CALLBACK AboutProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
		case WM_CLOSE:
			EndDialog(hwndDlg,0);
			break;
		case WM_COMMAND:
		{
			switch (LOWORD(wParam))
			{
				case IDOK:
					SendMessage(hwndDlg,WM_CLOSE,0,0);
					break;
			}
			break;
		}
		default:
			return FALSE;
	}
	return TRUE;
}

INT_PTR CALLBACK DlgParamProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
		case WM_INITDIALOG:
		{
			int i, paramcount = 0;
			char *found, nextchar, filename[512];
			HWND lstfiles;
			found = params;
			lstfiles = GetDlgItem(hwndDlg,MAKEINTRESOURCE(IDC_LSTSTATUS));
			ListView_AddTextColumn(&lstfiles, "File", 150, 0);
			ListView_AddTextColumn(&lstfiles, "Action", 200, 1);
			ListView_AddTextColumn(&lstfiles, "Directory", 400, 2);
			while ((found=strchr(found,'"')) != NULL)
			{
				found[0] = ' ';
				if (nextchar == 1)
				{
					paramcount++;
					if (found[1] == ' ')
					{
						found[1] = 0;
						found = found+2;
					}
					nextchar = 0;
				}
				else { nextchar = 1; }
			}
			found = params;
			while (paramcount > 0)
			{
				memset(filename,0,512);
				memcpy(filename,found+1,strlen(found)-2);
				if (CheckForPatch(filename) == ESR_FILE_ALREADY_PATCHED)
				{
					char message[768];
					memset(message,0,768);
					strcat(message,"This file is already patched:\n");
					strcat(message,filename);
					strcat(message,"\nwould you like it unpatched?");
					if (MessageBox(hwndDlg,message,"Notification",MB_ICONINFORMATION | MB_YESNO) == IDYES)
						AddFileToListView(&lstfiles,filename);
					else
					{
						int item;
						item = AddFileToListView(&lstfiles,filename);
						ListView_SetItemText(lstfiles,item,1,"No Action");
					}
				}
				else
					AddFileToListView(&lstfiles,filename);
				found+=strlen(found)+1;
				paramcount--;
			}
			free(params);
			PatchFilesInListView(GetDlgItem(hwndDlg,MAKEINTRESOURCE(IDC_LSTSTATUS)),NULL);
			break;
		}
		case WM_CLOSE:
			EndDialog(hwndDlg,0);
			break;
		case WM_COMMAND:
		{
			switch (LOWORD(wParam))
			{
				case IDOK:
					SendMessage(hwndDlg,WM_CLOSE,0,0);
					break;
				case IDCANCEL:
					SendMessage(hwndDlg,WM_CLOSE,0,0);
			}
			break;
		}
		default:
			return FALSE;
	}
	return TRUE;
}

INT_PTR CALLBACK DlgBatchProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static HWND filelist;
	static BYTE killparent = 2;
	static int awaitingclear = 0;
	switch (uMsg)
	{
		case WM_KEYDOWN:
		{
			MessageBox(NULL,"DELETE KEY PRESSED","TEST",MB_OK);
			break;
		}
		case WM_DROPFILES:
		{
			if (awaitingclear == 1)
			{
				ListView_DeleteAllItems(filelist);
				SendMessage(GetDlgItem(hwndDlg,MAKEINTRESOURCE(IDC_PATCHPROGRESS)),PBM_SETPOS,0,0);
				awaitingclear = 0;
			}
			int amount, i;
			char FileList[512];
			amount = DragQueryFile((HDROP)wParam,0xFFFFFFFF,FileList,512);
			for (i=0;i<amount;i++)
			{
				DragQueryFile((HDROP)wParam,i,FileList,512);
				AddFileToListView(&filelist, FileList);
			}
			break;
		}
		case WM_INITDIALOG:
		{
			HMENU mainmenu;
			filelist = GetDlgItem(hwndDlg,MAKEINTRESOURCE(IDC_LSTISO));
			ListView_AddTextColumn(&filelist, "File", 150, 0);
			ListView_AddTextColumn(&filelist, "Action", 200, 1);
			ListView_AddTextColumn(&filelist, "Directory", 400, 2);
			mainmenu = GetMenu(hwndDlg);
			EnableMenuItem(mainmenu,MAKEINTRESOURCE(IDM_BATCH1),MF_DISABLED | MF_GRAYED | MF_BYCOMMAND);
			EnableMenuItem(mainmenu,MAKEINTRESOURCE(IDM_SINGLE1),MF_ENABLED | MF_BYCOMMAND);
			CheckMenuItem(mainmenu,MAKEINTRESOURCE(IDM_BATCH1),MF_BYCOMMAND | MF_CHECKED);
			CheckMenuItem(mainmenu,MAKEINTRESOURCE(IDM_SINGLE1),MF_BYCOMMAND | MF_UNCHECKED);
			break;
		}
		case WM_CLOSE:
		{
			if (killparent == 2) { killparent = 1; }
			if (killparent == 1)
			{
				child = NULL;
				EndDialog(hwndDlg,0);
				SendMessage(mainwindow,WM_CLOSE,0,0);
			}
			else { ShowWindow(hwndDlg,SW_HIDE); ShowWindow(mainwindow,SW_SHOW); killparent = 2; }
			break;
		}
		case WM_COMMAND:
		{
			switch (LOWORD(wParam))
			{
				case IDC_BTNBEGIN:
				{
					if (awaitingclear == 1) {
						ListView_DeleteAllItems(filelist);
						awaitingclear = 0;
						SendMessage(GetDlgItem(hwndDlg,MAKEINTRESOURCE(IDC_PATCHPROGRESS)),PBM_SETPOS,0,0);
					}
					else
					{
						awaitingclear = 1;
						PatchFilesInListView(GetDlgItem(hwndDlg,MAKEINTRESOURCE(IDC_LSTISO)),GetDlgItem(hwndDlg,MAKEINTRESOURCE(IDC_PATCHPROGRESS)));
					}
					break;
				}
				case IDC_BTNCLEAR:
					ListView_DeleteAllItems(filelist);
					break;
				case IDM_SINGLE1:
					killparent = 0;
					SendMessage(hwndDlg,WM_CLOSE,0,0);
					break;
				case IDM_OPEN_FILE___1:
					if (awaitingclear == 1)
					{
						ListView_DeleteAllItems(filelist);
						SendMessage(GetDlgItem(hwndDlg,MAKEINTRESOURCE(IDC_PATCHPROGRESS)),PBM_SETPOS,0,0);
						awaitingclear = 0;
					}
					GetMultiOpen(&ofn,&filelist);
					break;
				case IDC_BTNADDFILE:
					if (awaitingclear == 1)
					{
						ListView_DeleteAllItems(filelist);
						SendMessage(GetDlgItem(hwndDlg,MAKEINTRESOURCE(IDC_PATCHPROGRESS)),PBM_SETPOS,0,0);
						awaitingclear = 0;
					}
					GetMultiOpen(&ofn,&filelist);
					break;
				case IDM_ABOUT:
					DialogBox(hInst,MAKEINTRESOURCE(IDD_DLGABOUT),hwndDlg,AboutProc);
					break;
				case IDC_BTNEXIT1:
					killparent = 1;
					SendMessage(hwndDlg,WM_CLOSE,0,0);
					break;
				case IDM_EXIT2:
					killparent = 1;
					SendMessage(hwndDlg,WM_CLOSE,0,0);
					break;
				case IDC_BTNSINGLEMODE:
					killparent = 0;
					SendMessage(hwndDlg,WM_CLOSE,0,0);
					break;
			}
			break;
		}
		default:
			return FALSE;
	}
	return TRUE;
}

void chrtoup(char *str)
{
	int slen, i;
	slen = strlen(str);
	for (i=0;i<slen;i++)
	{
		str[i] = toupper(str[i]);
	}
}

INT_PTR CALLBACK DlgSingleProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static HWND btngo, txtfilename;
	switch (uMsg)
	{
		case WM_INITDIALOG:
			txtfilename = GetDlgItem(hwndDlg,MAKEINTRESOURCE(IDC_TXTFILENAME));
			btngo = GetDlgItem(hwndDlg,MAKEINTRESOURCE(IDC_BTNGO));
			mainwindow = hwndDlg;
			break;
		case WM_CLOSE:
			if (child != NULL) { SendMessage(child,WM_CLOSE,0,0); }
			EndDialog(hwndDlg,0);
			break;
		case WM_DROPFILES:
		{
			HDROP drophandle;
			memset(selectedFiles,0,512);
			drophandle = (HDROP)wParam;
			DragQueryFile(drophandle,0,selectedFiles,512);
			if (SupportedFile(selectedFiles))
			{
				SetWindowText(txtfilename,selectedFiles);
				CheckFile(selectedFiles,&hwndDlg,&btngo);
			}
			break;
		}
		case WM_COMMAND:
		{
			switch (LOWORD(wParam))
			{
				case IDCANCEL:
					SendMessage(hwndDlg,WM_CLOSE,0,0);
					break;
				case IDM_ABOUT:
					DialogBox(hInst,MAKEINTRESOURCE(IDD_DLGABOUT),hwndDlg,AboutProc);
					break;
				case IDM_BATCH1:
					if (child == NULL) { child = BatchMode(&hwndDlg); }
					else { ShowWindow(hwndDlg,SW_HIDE); ShowWindow(child,SW_SHOW); }
					break;
				case IDC_BTNBATCHMODE:
					if (child == NULL) { child = BatchMode(&hwndDlg); }
					else { ShowWindow(hwndDlg,SW_HIDE); ShowWindow(child,SW_SHOW); }
					break;
				case IDM_EXIT2:
					SendMessage(hwndDlg,WM_CLOSE,0,0);
					break;
				case IDC_BTNEXIT2:
					SendMessage(hwndDlg,WM_CLOSE,0,0);
					break;
				case IDC_BTNGO:
				{
					ERRCHECK errors;
					if (mode == 0) { errors = ESRErrorCheck(PatchFile(selectedFiles)); }
					else {errors = ESRErrorCheck(UnPatchFile(selectedFiles)); }
					if (errors.errorcode == ESR_FILE_OK)
					{
						if (mode == 0) { mode = 1; }
						else { mode = 0; }
						SetupStatusText(&btngo);
					}
					MessageBox(hwndDlg,errors.mbmessage,errors.mbtitle,errors.mbflags);
					break;
				}
				case IDC_BTNBROWSEFILE:
					GetSingleOpen(&ofn,&btngo,&txtfilename,&hwndDlg);
					break;
				case IDM_OPEN_FILE___1:
					GetSingleOpen(&ofn,&btngo,&txtfilename,&hwndDlg);
					break;
			}
			break;
		}
		default:
			return FALSE;
	}
	return TRUE;
}

HWND BatchMode(HWND *caller)
{
	ShowWindow(*caller,SW_HIDE);

	return CreateDialog(hInst,MAKEINTRESOURCE(IDD_DLGBATCH),NULL,DlgBatchProc);
}

void GetMultiOpen(OPENFILENAME *openfile, HWND *addtolst)
{
	memset(selectedFiles,0,512);
	openfile->Flags = OFN_ALLOWMULTISELECT | OFN_EXPLORER | OFN_FILEMUSTEXIST;
	if (GetOpenFileName(openfile))
	{
		int curcheck;
		curcheck = openfile->nFileOffset;
		if (selectedFiles[curcheck-1] == 0)
		{
			while (strlen(selectedFiles+curcheck) != 0)
			{
				int check = 0;
				char fullfile[512];
				memset(fullfile,0,512);
				strcat(fullfile,selectedFiles);
				strcat(fullfile,"\\");
				strcat(fullfile,selectedFiles+curcheck);
				AddFileToListView(addtolst,fullfile);
				curcheck+=strlen(selectedFiles+curcheck)+1;
			}
		}
		else
				AddFileToListView(addtolst,selectedFiles);
	}
}

void GetSingleOpen(OPENFILENAME *openfile, HWND *status, HWND *outfilename, HWND *winhandle)
{
	memset(selectedFiles,0,512);
	openfile->Flags = OFN_FILEMUSTEXIST | OFN_EXPLORER;
	if (GetOpenFileName(openfile))
	{
		SetWindowText(*outfilename,selectedFiles);
		CheckFile(selectedFiles,winhandle,status);
	}
}

void CheckFile(char *filename, HWND *winhandle, HWND *enablewin)
{
		EnableWindow(*enablewin,TRUE);
		ERRCHECK errors;
		errors = ESRErrorCheck(CheckForPatch(selectedFiles));
		switch (errors.errorcode)
		{
			case ESR_FILE_ALREADY_PATCHED:
				mode = 1;
				SetupStatusText(enablewin);
				break;
			case ESR_FILE_CANNOT_OPEN:
				MessageBox(*winhandle,errors.mbmessage,errors.mbtitle,errors.mbflags);
				EnableWindow(*enablewin,FALSE);
				break;
			case ESR_FILE_WRONG_FORMAT:
				MessageBox(*winhandle,errors.mbmessage,errors.mbtitle,errors.mbflags);
				EnableWindow(*enablewin,FALSE);
				break;
			case ESR_FILE_NO_UDF_DESCRIPTOR:
				MessageBox(*winhandle,errors.mbmessage,errors.mbtitle,errors.mbflags);
				EnableWindow(*enablewin,FALSE);
				break;
			default:
				mode = 0;
				SetupStatusText(enablewin);
		}
}

ERRCHECK ESRErrorCheck(int patchfunc)
{
	ERRCHECK mb;
	mb.mbtitle = "Error";
	mb.mbflags = MB_ICONERROR | MB_OK;
	switch (patchfunc)
	{
		case ESR_FILE_CANNOT_OPEN:
			mb.mbmessage = "Cannot Open File";
			break;
		case ESR_FILE_NO_UDF_DESCRIPTOR:
			mb.mbmessage = "No UDF Descriptor in file";
			break;
		case ESR_FILE_WRONG_FORMAT:
			mb.mbmessage = "Files is not a supported format";
			break;
		case ESR_FILE_OK:
			if (mode == 0) { mb.mbmessage = "File successfully patched"; }
			if (mode == 1) { mb.mbmessage = "File successfully unpatched"; }
			mb.mbtitle = "Success";
			mb.mbflags = MB_ICONINFORMATION | MB_OK;
	}
	mb.errorcode = patchfunc;
	return mb;
}

void SetupStatusText(HWND *status)
{
	if (mode == 0) { SetWindowText(*status,"Patch"); }
	else if (mode == 1) { SetWindowText(*status,"Unpatch"); }
}

int AddFileToListView(HWND *listview, char *filename)
{
	if (SupportedFile(filename) == 1)
	{
		int i, check, inserted;
		char add = 1;
		char *remove;
		LVITEM newitem;
		newitem.mask = LVIF_TEXT;
		newitem.iItem = 0;
		newitem.iSubItem = 0;
		check = CheckForPatch(filename);
		remove = strrchr(filename,'\\');
		*remove = 0;
		newitem.pszText = remove+1;;
		for (i=0;i<ListView_GetItemCount(*listview);i++)
		{
			char inlist[512];
			memset(inlist,0,512);
			ListView_GetItemText(*listview,i,0,inlist,512);
			if (strcmp(remove+1,inlist) == 0)
			{
				ListView_GetItemText(*listview,i,2,inlist,512);
				if (strcmp(filename,inlist) == 0) { add = 0; }
			}
		}
		if (add == 1)
		{
			inserted = ListView_InsertItem(*listview,&newitem);
			if (check == 0) { ListView_SetItemText(*listview,inserted,1,"Patch"); }
			else if (check == -2) { ListView_SetItemText(*listview,inserted,1,"Unpatch"); }
			else { ListView_SetItemText(*listview,inserted,1,"Cannot Patch"); }
			ListView_SetItemText(*listview,inserted,2,filename);
			return inserted;
		}
		else { return -1; }
	}
}

void ListView_AddTextColumn(HWND *listview, char *text, int width, int columnno)
{
	LVCOLUMN column;
	column.mask = LVCF_TEXT | LVCF_WIDTH;
	column.pszText = text;
	column.cx = width;
	ListView_InsertColumn(*listview,columnno,&column);
}

void PatchFilesInListView(HWND listview, HWND progressbar)
{
	int filecount, i;
	char dir[512], file[512], ready[1024];
	char mode[13];
	filecount = ListView_GetItemCount(listview);
	SendMessage(progressbar,PBM_SETRANGE,0,MAKELPARAM(0,filecount));
	SendMessage(progressbar,PBM_SETPOS,0,0);
	for (i=0;i<filecount;i++)
	{
		LVITEM specs;
		SendMessage(progressbar,PBM_SETPOS,i,0);
		memset(ready,0,1024);
		memset(mode,13,0);
		specs.iItem = i;
		specs.iSubItem = 2;
		specs.mask = LVIF_TEXT;
		specs.pszText = dir;
		specs.cchTextMax = 512;
		ListView_GetItem(listview,&specs);
		specs.iSubItem = 0;
		specs.pszText = file;
		ListView_GetItem(listview,&specs);
		strcat(ready,dir);
		strcat(ready,"\\");
		strcat(ready,file);
		specs.iSubItem = 1;
		specs.pszText = mode;
		specs.cchTextMax = 13;
		ListView_GetItem(listview,&specs);
		if (mode[0] == 'P')
		{
			if (PatchFile(ready) == 0)
			{
				mode[5] = 'e';
				mode[6] = 'd';
				mode[7] = 0;
			}
			else { strcpy(mode,"Failure"); }
		}
		else if (mode[0] == 'U')
		{
			if (UnPatchFile(ready) == 0)
			{
				mode[7] = 'e';
				mode[8]	= 'd';
				mode[9] = 0;
			}
			else { strcpy(mode,"Failure"); }
		}
		ListView_SetItemText(listview,i,1,mode);
	}
	SendMessage(progressbar,PBM_SETPOS,filecount,0);
}

char SupportedFile(char *filename)
{
	char *extension, extcmp[4];
	extension = strrchr(filename,'.');
	extension += 1;
	memcpy(extcmp,extension,4);
	extcmp[3] = 0;
	chrtoup(extcmp);
	if (strcmp(extcmp,"ISO") == 0)
		return 1;
	else
		return 0;
}
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	hInst = hInstance;
	memset(&ofn,0,sizeof(ofn));
	memset(selectedFiles,0,512);
	ofn.lStructSize = sizeof(ofn);
	ofn.hInstance = hInst;
	ofn.lpstrFilter = "ISO Files (*.iso)\0*.iso\0";
	ofn.lpstrFile = selectedFiles;
	ofn.nMaxFile = 512;
	ofn.lpstrInitialDir = ".\\";
	InitCommonControls();
	if (lpCmdLine[0] == 0)
		return DialogBox(hInst,MAKEINTRESOURCE(IDD_DLGSINGLE),NULL,DlgSingleProc);
	else
	{
		params = malloc(strlen(lpCmdLine));
		strcpy(params,lpCmdLine);
		return DialogBox(hInst,MAKEINTRESOURCE(IDD_DLGPARAM),NULL,DlgParamProc);
	}
}
